----------------------------------------------------------------------------
-- @Author: ViperGTS96------------------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design." --------------
----------------------------------------------------------------------------
----------------------------------------------------------------------------

aquaTraxxEffects = {}
aquaTraxxEffects.dir = g_currentModDirectory;
aquaTraxxEffects.unloadKeys = {};
aquaTraxxEffects.toggleCapKeys = {};
aquaTraxxEffects.keyDown = false;
aquaTraxxEffects.manualUnloadTrigger = -1;
aquaTraxxEffects.manualOpenCapTrigger = -1;

function aquaTraxxEffects:delete()
	aquaTraxxEffects = {};
end;

function aquaTraxxEffects:draw()
	if aquaTraxxEffects.manualUnloadTrigger ~= -1 or aquaTraxxEffects.manualOpenCapTrigger ~= -1 then
		local waterTrailer = nil;
		local onNotOff = false;
		local openNotClosed = false;
		local spoutNotcap = false;
		for _, vehicle in pairs(g_currentMission.vehicles) do
			if vehicle.spec_waterTrailer ~= nil and vehicle.spec_waterTrailer.manuallyDraining ~= nil then
				if vehicle.spec_waterTrailer.triggerId == aquaTraxxEffects.manualUnloadTrigger then
					waterTrailer = vehicle;
					onNotOff = vehicle.spec_waterTrailer.manuallyDraining;
					spoutNotcap = true;
				elseif vehicle.spec_waterTrailer.capTriggerId == aquaTraxxEffects.manualOpenCapTrigger then
					waterTrailer = vehicle;
					openNotClosed = vehicle.spec_waterTrailer.manuallyOpenedCap;
				end;
			end;
		end;
		if waterTrailer ~= nil then
			local uiScale = g_gameSettings:getValue("uiScale");
			local textSize = 0.02*uiScale;
			local oX = textSize * HUDTextDisplay.SHADOW_OFFSET_FACTOR;
			if spoutNotcap then
				local keyString = string.upper(string.gsub(aquaTraxxEffects.unloadKeys[1],"KEY_",""));
				if onNotOff then --Spout
					-----------------------Start Shadow-------------------------------------------
					local renderString = "Press '"..keyString.."' to close the Watertank's valve";
					setTextBold(false);
					setTextColor(0,0,0,1);
					setTextAlignment(RenderText.ALIGN_CENTER);
					renderText(0.5+oX,0.1-oX,textSize,renderString);
					------------------------------------------------------------------------------
					setTextColor(0,0.5,1,1);
					renderText(0.5,0.1,textSize,renderString);
					------------------------------------------------------------------------------
					g_currentMission:addExtraPrintText("Press '"..keyString.."' to Stop Manual Unloading");
				else
					-----------------------Start Shadow-------------------------------------------
					local renderString = "Press '"..keyString.."' to open the Watertank's valve";
					setTextBold(false);
					setTextColor(0,0,0,1);
					setTextAlignment(RenderText.ALIGN_CENTER);
					renderText(0.5+oX,0.1-oX,textSize,renderString);
					------------------------------------------------------------------------------
					setTextColor(0,0.5,1,1);
					renderText(0.5,0.1,textSize,renderString);
					------------------------------------------------------------------------------
					g_currentMission:addExtraPrintText("Press '"..keyString.."' to Start Manual Unloading");
				end;
			else-------------------------------------------------------------------------------------------------------
				local keyString = string.upper(string.gsub(aquaTraxxEffects.toggleCapKeys[1],"KEY_",""));
				if openNotClosed then --Cap
					-----------------------Start Shadow-------------------------------------------
					local renderString = "Press '"..keyString.."' to close the Watertank's cap";
					setTextBold(false);
					setTextColor(0,0,0,1);
					setTextAlignment(RenderText.ALIGN_CENTER);
					renderText(0.5+oX,0.1-oX,textSize,renderString);
					------------------------------------------------------------------------------
					setTextColor(0,0.5,1,1);
					renderText(0.5,0.1,textSize,renderString);
					------------------------------------------------------------------------------
					g_currentMission:addExtraPrintText("Press '"..keyString.."' to Close the fillcap");
				else
					-----------------------Start Shadow-------------------------------------------
					local renderString = "Press '"..keyString.."' to open the Watertank's cap";
					setTextBold(false);
					setTextColor(0,0,0,1);
					setTextAlignment(RenderText.ALIGN_CENTER);
					renderText(0.5+oX,0.1-oX,textSize,renderString);
					------------------------------------------------------------------------------
					setTextColor(0,0.5,1,1);
					renderText(0.5,0.1,textSize,renderString);
					------------------------------------------------------------------------------
					g_currentMission:addExtraPrintText("Press '"..keyString.."' to Open the fillcap");
				end;
			end;
		end;
	end;
end;

function aquaTraxxEffects:loadMap(savegame)
	Attachable.onLoadFinished = Utils.appendedFunction(Attachable.onLoadFinished, aquaTraxxEffects.onLoadFinished);
	WaterTrailer.onLoad = Utils.appendedFunction(WaterTrailer.onLoad, aquaTraxxEffects.onLoad);
	WaterTrailer.onUpdateTick = Utils.appendedFunction(WaterTrailer.onUpdateTick, aquaTraxxEffects.onUpdateTick);
	WaterTrailer.onDelete = Utils.appendedFunction(WaterTrailer.onDelete, aquaTraxxEffects.onDelete);
	Player.onLeave = Utils.appendedFunction(Player.onLeave, aquaTraxxEffects.onLeave);
end;


function aquaTraxxEffects:onDelete()
    if self.spec_waterTrailer ~= nil then
		if self.spec_waterTrailer.triggerId ~= nil then
			removeTrigger(self.spec_waterTrailer.triggerId);
		end;
		if self.spec_waterTrailer.capTriggerId ~= nil then
			removeTrigger(self.spec_waterTrailer.capTriggerId);
		end;
    end;
end;

function aquaTraxxEffects:onLeave()
	if self.spec_waterTrailer ~= nil and self.spec_waterTrailer.psSystem ~= nil then
		local waterTrailer = self.spec_waterTrailer;
		if not waterTrailer.manuallyDraining then
			aquaTraxxEffects:togglePS(waterTrailer, false);
		end;
	end;
end;

function aquaTraxxEffects:playerTriggerCallback(triggerId, otherId, onEnter, onLeave, onStay)--Rear Spout
	if g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		if onEnter then
			self.manualUnloadTrigger = triggerId;
		elseif onLeave then
			self.manualUnloadTrigger = -1;
		end;
	end;
end;

function aquaTraxxEffects:playerTrigger2Callback(triggerId, otherId, onEnter, onLeave, onStay)--Cap
	if g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		if onEnter then
			self.manualOpenCapTrigger = triggerId;
		elseif onLeave then
			self.manualOpenCapTrigger = -1;
		end;
	end;
end;

function aquaTraxxEffects:configureWaterPlanes(waterPlanes)

	local plane100 = getChildAt(waterPlanes, 0);
	local plane80 = getChildAt(waterPlanes, 1);
	local plane60 = getChildAt(waterPlanes, 2);
	local plane40 = getChildAt(waterPlanes, 3);
	local plane20 = getChildAt(waterPlanes, 4);
	local plane0 = getChildAt(waterPlanes, 5);
	local effectShape = getChildAt(waterPlanes, 6);
	waterPlanes = {plane100,plane80,plane60,plane40,plane20,plane0};
	-----------
	local waterEffect = {};
	waterEffect.shape = effectShape;
	local g_detector1 = getChildAt(effectShape, 0);
	local g_detector2 = getChildAt(effectShape, 1);
	local g_detector3 = getChildAt(effectShape, 2);
	local g_detector4 = getChildAt(effectShape, 3);
	local g_detector5 = getChildAt(effectShape, 4);
	local g_detector6 = getChildAt(effectShape, 5);
	waterEffect.splashesShape = getChildAt(effectShape, 6);
	waterEffect.g_detectors = {g_detector1,g_detector2,g_detector3,g_detector4,g_detector5,g_detector6};
	return waterPlanes, waterEffect;
end;

function aquaTraxxEffects:onLoad()
	if hasXMLProperty(self.xmlFile, "vehicle.waterTrailer.traxx") then
		if self.spec_waterTrailer ~= nil then
			local waterTrailer = self.spec_waterTrailer;
			if waterTrailer.psSystem == nil then
				waterTrailer.emitterNode = I3DUtil.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.waterTrailer.traxx.rearSpout#emitter"));
				waterTrailer.spoutLever = I3DUtil.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.waterTrailer.traxx.rearSpout#leverHandle"));
				waterTrailer.triggerId = I3DUtil.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.waterTrailer.traxx.rearSpout#manualTrigger"));
				waterTrailer.capTriggerId = I3DUtil.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.waterTrailer.traxx.fillcap#manualTrigger"));
				waterTrailer.waterPlanes = I3DUtil.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.waterTrailer.traxx.waterPlanes#groupNode"));
				if (waterTrailer.emitterNode == nil or waterTrailer.spoutLever == nil or waterTrailer.triggerId == nil or waterTrailer.waterPlanes == nil) then
				print("Error loading AquaTraxxEffects' Nodes"); return; end;
				if dirtToMudConverter ~= nil then aquaTraxxEffects.unloadKeys = dirtToMudConverter.unloadKeys; end;
				if aquaTraxxEffects.unloadKeys == nil or #aquaTraxxEffects.unloadKeys < 1 then print("Error loading AquaTraxxEffects' Unload Keys"); return; end;
				if aquaTraxxEffects.toggleCapKeys == nil or #aquaTraxxEffects.toggleCapKeys < 1 then print("Error loading AquaTraxxEffects' Cap Keys"); return; end;
				-----
				waterTrailer.waterPlanes, waterTrailer.waterEffect = aquaTraxxEffects:configureWaterPlanes(waterTrailer.waterPlanes);
				if (waterTrailer.waterPlanes == nil or waterTrailer.waterEffect == nil) then
				print("Error loading AquaTraxxEffects' Nodes"); return; end;
				setVisibility(waterTrailer.waterEffect.shape, false);
				setVisibility(waterTrailer.waterEffect.splashesShape, false);
				setScale(waterTrailer.waterEffect.shape, 1,1,0.8);
				-----
				waterTrailer.preDrainAmount = 0;
				waterTrailer.maxFillCapacity = self:getFillUnitCapacity(waterTrailer.fillUnitIndex);
				waterTrailer.manuallyDraining = false;
				waterTrailer.manuallyOpenedCap = false;
				-----flowPS
				waterTrailer.psSystem = {};
				local psData = {};
				psData.psFile = "trailer/aquatraxx_ps.i3d";
				psData.posX, psData.posY, psData.posZ = 0,0.04,0;
				psData.worldSpace = false;
				ParticleUtil.loadParticleSystemFromData(psData, waterTrailer.psSystem, nil, false, nil, aquaTraxxEffects.dir, waterTrailer.emitterNode);
				waterTrailer.psSystem.isActive = false;
				------groundPS
				waterTrailer.waterEffect.psSystem = {};
				psData.psFile = "trailer/aquatraxx_psG.i3d";
				psData.posX, psData.posY, psData.posZ = 0,0,0;
				ParticleUtil.loadParticleSystemFromData(psData, waterTrailer.waterEffect.psSystem, nil, false, nil, aquaTraxxEffects.dir, waterTrailer.waterEffect.shape);
				waterTrailer.waterEffect.psSystem.isActive = false;
				------
				--self.playerTriggerCallback = SpecializationUtil.callSpecializationsFunction("playerTriggerCallback");
				addTrigger(waterTrailer.triggerId, "playerTriggerCallback", aquaTraxxEffects);
				addTrigger(waterTrailer.capTriggerId, "playerTrigger2Callback", aquaTraxxEffects);
				------
				print("Load mod: WaterTrailer:AquaTraxxEffects");
			end;
		end;
	end;
end;

function aquaTraxxEffects:onLoadFinished()
	if self.spec_waterTrailer ~= nil then
		local waterTrailer = self.spec_waterTrailer;
		if waterTrailer.psSystem ~= nil then
			waterTrailer.preDrainAmount = self:getFillUnitFillLevel(waterTrailer.fillUnitIndex);
		end;
	end;
end;

function aquaTraxxEffects:getGroundSplashHeight(waterEffect)
	local g1,g2,g3,g4,g5,g6 = unpack(waterEffect.g_detectors);

	local x1,y1,z1 = getWorldTranslation(g1);
	local yy1 = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x1,y1,z1);
	local x2,y2,z2 = getWorldTranslation(g2);
	local yy2 = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x2,y2,z2);
	local x3,y3,z3 = getWorldTranslation(g3);
	local yy3 = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x3,y3,z3);
	local x4,y4,z4 = getWorldTranslation(g4);
	local yy4 = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x4,y4,z4);
	local x5,y5,z5 = getWorldTranslation(g5);
	local yy5 = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x5,y5,z5);
	local x6,y6,z6 = getWorldTranslation(g6);
	local yy6 = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x6,y6,z6);
	local l1 = y1-yy1; if l1 < 0 then l1=l1*(-1); end;
	local l2 = y2-yy2; if l2 < 0 then l2=l2*(-1); end;
	local l3 = y3-yy3; if l3 < 0 then l3=l3*(-1); end;
	local l4 = y4-yy4; if l4 < 0 then l4=l4*(-1); end;
	local l5 = y5-yy5; if l5 < 0 then l5=l5*(-1); end;
	local l6 = y6-yy6; if l6 < 0 then l6=l6*(-1); end;

	if math.min(l1,l2,l3,l4,l5,l6) == l1 then
		return x1,yy1,z1;
	elseif math.min(l1,l2,l3,l4,l5,l6) == l2 then
		return x2,yy2,z2;
	elseif math.min(l1,l2,l3,l4,l5,l6) == l3 then
		return x3,yy3,z3;
	elseif math.min(l1,l2,l3,l4,l5,l6) == l4 then
		return x4,yy4,z4;
	elseif math.min(l1,l2,l3,l4,l5,l6) == l5 then
		return x5,yy5,z5;
	elseif math.min(l1,l2,l3,l4,l5,l6) == l6 then
		return x6,yy6,z6;
	end;

	return x4,y4,z4; -- default local ground level of trailer..
end;

function aquaTraxxEffects:toggleLever(node, onOff)
	if onOff and y ~= math.rad(90) then
		setRotation(node,0,math.rad(-90),0);
	elseif not onOff and y ~= 0 then
		setRotation(node,0,0,0);
	end;
end;

function aquaTraxxEffects:resetSplashes(waterEffect)
	if waterEffect.psSystem.isActive then
		local _,y,_ = getTranslation(waterEffect.psSystem.shape);
		if y ~= 0 then setTranslation(waterEffect.psSystem.shape,0,0,0); end;
		ParticleUtil.setEmittingState(waterEffect.psSystem, false);
		setVisibility(waterEffect.splashesShape, false);
		waterEffect.psSystem.isActive = false;
	end;
end;

function aquaTraxxEffects:alignSplashesToGround(splashShape)
    local x1,y1,z1 = localToWorld(splashShape,0,0,1);
    local x2,y2,z2 = localToWorld(splashShape,0,0,-1);
    local x3,y3,z3 = localToWorld(splashShape,1,0,0);
    local x4,y4,z4 = localToWorld(splashShape,-1,0,0);
    y1 = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x1,y1,z1);
    y2 = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x2,y2,z2);
    y3 = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x3,y3,z3);
    y4 = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x4,y4,z4);
    local dirX = x2 - x1;
    local dirY = y2 - y1;
    local dirZ = z2 - z1;
    local dir2X = x3 - x4;
    local dir2Y = y3 - y4;
    local dir2Z = z3 - z4;
    local upX,upY,upZ = MathUtil.crossProduct(dir2X, dir2Y, dir2Z, dirX, dirY, dirZ);
    setDirection(getChildAt(splashShape,0), dirX, dirY, dirZ, upX,upY,upZ);
end;

function aquaTraxxEffects:updateSplashes(waterTrailer)
	if waterTrailer.psSystem.isActive then
		local x,y,z = aquaTraxxEffects:getGroundSplashHeight(waterTrailer.waterEffect)
		local x1,y1,z1 = getWorldTranslation(waterTrailer.waterEffect.psSystem.shape);
		-----
		if (x+y+z)~=(x1+y1+z1) then
			setWorldTranslation(waterTrailer.waterEffect.psSystem.shape,x,y,z);
			setWorldTranslation(waterTrailer.waterEffect.splashesShape,x,y,z);
			aquaTraxxEffects:alignSplashesToGround(waterTrailer.waterEffect.splashesShape);
		else-----
			if not waterTrailer.waterEffect.psSystem.isActive then
				local x,y,z = getWorldTranslation(waterTrailer.waterEffect.psSystem.shape);
				local yy = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x,y+0.01,z);
				if y <= (yy+0.01) and y >= (yy-0.01) then --slight tolerance given
					waterTrailer.waterEffect.psSystem.isActive = true;
					ParticleUtil.setEmittingState(waterTrailer.waterEffect.psSystem, true);
					setVisibility(waterTrailer.waterEffect.splashesShape, true);
				end;
			end;
		end;
	end;
end;

function aquaTraxxEffects:togglePS(waterTrailer, onOff)
	if waterTrailer.psSystem.isActive ~= onOff then
		waterTrailer.psSystem.isActive = onOff;
		aquaTraxxEffects:toggleLever(waterTrailer.spoutLever, onOff);
		ParticleUtil.setEmittingState(waterTrailer.psSystem, onOff);
		setVisibility(waterTrailer.waterEffect.shape, onOff);
		if onOff == false then aquaTraxxEffects:resetSplashes(waterTrailer.waterEffect); end;
	end;
end;

function aquaTraxxEffects:setTankWaterVisibility(waterTrailer, fillLevel)
	fillLevel = fillLevel/waterTrailer.maxFillCapacity;
	if fillLevel >= 0.9 then
		if not getVisibility(waterTrailer.waterPlanes[1]) then setVisibility(waterTrailer.waterPlanes[1], true); end;
	else
		if getVisibility(waterTrailer.waterPlanes[1]) then setVisibility(waterTrailer.waterPlanes[1], false); end;
	end;
	if fillLevel >= 0.7 and fillLevel < 0.9 then
		if not getVisibility(waterTrailer.waterPlanes[2]) then setVisibility(waterTrailer.waterPlanes[2], true); end;
	else
		if getVisibility(waterTrailer.waterPlanes[2]) then setVisibility(waterTrailer.waterPlanes[2], false); end;
	end;
	if fillLevel >= 0.5 and fillLevel < 0.7 then
		if not getVisibility(waterTrailer.waterPlanes[3]) then setVisibility(waterTrailer.waterPlanes[3], true); end;
	else
		if getVisibility(waterTrailer.waterPlanes[3]) then setVisibility(waterTrailer.waterPlanes[3], false); end;
	end;
	if fillLevel >= 0.3 and fillLevel < 0.5 then
		if not getVisibility(waterTrailer.waterPlanes[4]) then setVisibility(waterTrailer.waterPlanes[4], true); end;
	else
		if getVisibility(waterTrailer.waterPlanes[4]) then setVisibility(waterTrailer.waterPlanes[4], false); end;
	end;
	if fillLevel >= 0.1 and fillLevel < 0.3 then
		if not getVisibility(waterTrailer.waterPlanes[5]) then setVisibility(waterTrailer.waterPlanes[5], true); end;
	else
		if getVisibility(waterTrailer.waterPlanes[5]) then setVisibility(waterTrailer.waterPlanes[5], false); end;
	end;
	if fillLevel < 0.1 then
		if not getVisibility(waterTrailer.waterPlanes[6]) then setVisibility(waterTrailer.waterPlanes[6], true); end;
	else
		if getVisibility(waterTrailer.waterPlanes[6]) then setVisibility(waterTrailer.waterPlanes[6], false); end;
	end;
end;

function aquaTraxxEffects:onUpdateTick(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected)
	if isActiveForInput then
		if self.spec_waterTrailer ~= nil and self.spec_waterTrailer.psSystem ~= nil then
			local waterTrailer = self.spec_waterTrailer;
			local fillLvl = self:getFillUnitFillLevel(waterTrailer.fillUnitIndex);
			local isOverLoading = false;
			if self:getDischargeState() == Dischargeable.DISCHARGE_STATE_OBJECT then
				local dischargeObj = self:getCurrentDischargeObject(self:getCurrentDischargeNode());
				--[[for i,e in pairs(dischargeObj) do
					--print(i..":"..tostring(e));					
				end;]]
				if dischargeObj ~= nil and dischargeObj.vehicleNodes ~= nil then
					isOverLoading = true;
				end;
			end;
			if not isOverLoading then
				if fillLvl < waterTrailer.preDrainAmount then
					aquaTraxxEffects:togglePS(waterTrailer, true);
				elseif fillLvl > waterTrailer.preDrainAmount then				
					if self.spec_cover ~= nil and self.spec_cover.state ~= 1 then
						self:setCoverState(1, true);
					end;
				--	waterTrailer.preDrainAmount = fillLvl;
				--elseif fillLvl > 0 and waterTrailer.preDrainAmount <= 0 then
				--	waterTrailer.preDrainAmount = fillLvl;
				elseif not waterTrailer.manuallyDraining then
					aquaTraxxEffects:togglePS(waterTrailer, false);
				end;
			elseif not waterTrailer.manuallyDraining then
				aquaTraxxEffects:togglePS(waterTrailer, false);
			end;			
			if waterTrailer.preDrainAmount ~= fillLvl then waterTrailer.preDrainAmount = fillLvl; end;
		end;
	end;
end;

function aquaTraxxEffects:update(dt)
	local aquaTrailer;
	local spout;
	for _, vehicle in pairs(g_currentMission.vehicles) do
		if vehicle.spec_waterTrailer ~= nil and vehicle.spec_waterTrailer.spoutLever ~= nil then
			aquaTrailer = vehicle;
			spout = vehicle.spec_waterTrailer.spoutLever;
		end;
	end;
	if aquaTrailer ~= nil and spout ~= nil then -- is Aqautraxx
		self = aquaTrailer;
		local waterTrailer = self.spec_waterTrailer;
		local fillLvl = self:getFillUnitFillLevel(waterTrailer.fillUnitIndex);		
		aquaTraxxEffects:setTankWaterVisibility(waterTrailer, fillLvl);
		aquaTraxxEffects:updateSplashes(waterTrailer);
		if waterTrailer.isFilling then
			if self.spec_cover ~= nil and self.spec_cover.state ~= 1 then
				self:setCoverState(1, true);
			end;
		end;
		if waterTrailer.triggerId == aquaTraxxEffects.manualUnloadTrigger and fillLvl > 0 then --Start Manual Unloading
			local dischargeable = self.spec_dischargeable; if dischargeable ~= nil then dischargeable = dischargeable.currentDischargeNode; end;
			if dischargeable ~= nil and dischargeable.activationTrigger ~= nil and dischargeable.activationTrigger.numObjects > 0 then
				self:raiseActive();
				SpecializationUtil.raiseEvent(self, "onDischargeStateChanged", Dischargeable.DISCHARGE_STATE_OBJECT);
			else
				if Input.isKeyPressed(Input[aquaTraxxEffects.unloadKeys[1]]) and not aquaTraxxEffects.keyDown then
					aquaTraxxEffects.keyDown = true;
					--if calcDistanceFrom(waterTrailer.spoutLever, g_currentMission.player.rootNode) < 5 then
						if waterTrailer.manuallyDraining then
							waterTrailer.manuallyDraining = false;
							aquaTraxxEffects:togglePS(waterTrailer, false);
						else
							waterTrailer.manuallyDraining = true;
						end;
					--end;
				end;			
			end;
		elseif waterTrailer.capTriggerId == aquaTraxxEffects.manualOpenCapTrigger then
			if Input.isKeyPressed(Input[aquaTraxxEffects.toggleCapKeys[1]]) and not aquaTraxxEffects.keyDown then
				aquaTraxxEffects.keyDown = true;
				if self.spec_cover ~= nil then
					Cover.actionEventToggleCover(self,nil,nil,nil);
					waterTrailer.manuallyOpenedCap = (self.spec_cover.state > 0);--not waterTrailer.manuallyOpenedCap;
				end;
			end;
		end;
	
		local playingSound = false;

		if waterTrailer.manuallyDraining and fillLvl > 0 then
			aquaTraxxEffects:togglePS(waterTrailer, true);
			--local manualDrainSpeed = waterTrailer.fillLitersPerSecond*(dt*0.0001);
			local emptySpeed = (waterTrailer.fillLitersPerSecond/1000); emptySpeed=emptySpeed*(emptySpeed*dt);
			self:addFillUnitFillLevel(self:getOwnerFarmId(), waterTrailer.fillUnitIndex, -emptySpeed, FillType.WATER, ToolType.UNDEFINED, nil);
			playingSound = true;
			if self.spec_attachable ~= nil and self.spec_dischargeable ~= nil then
				local rootVehicle = self.spec_attachable.attacherVehicle;
				local dischargeable = self.spec_dischargeable;
				if rootVehicle ~= nil and rootVehicle.spec_enterable ~= nil then
					local enterable = rootVehicle.spec_enterable;
					if enterable.isEntered and dischargeable.currentDischargeState == Dischargeable.DISCHARGE_STATE_OFF then -- if rootVehicle is entered update trailer to unloading..
						if dischargeable.currentDischargeNode ~= nil then dischargeable = dischargeable.currentDischargeNode; 
							if dischargeable.activationTrigger ~= nil and dischargeable.activationTrigger.numObjects > 0 then
								SpecializationUtil.raiseEvent(self, "onDischargeStateChanged", Dischargeable.DISCHARGE_STATE_OBJECT);
								--self:discharge(dischargeNode, drainAmount);
								waterTrailer.manuallyDraining = false;
							--else
								--SpecializationUtil.raiseEvent(self, "onDischargeStateChanged", Dischargeable.DISCHARGE_STATE_GROUND);
							end;
						end;
					end;
				end;
			end;
		elseif waterTrailer.manuallyDraining then
			waterTrailer.manuallyDraining = false;
			aquaTraxxEffects:togglePS(waterTrailer, false);
		end;

		if playingSound and not g_soundManager:getIsSamplePlaying(waterTrailer.samples.refill) then
			g_soundManager:playSample(waterTrailer.samples.refill);
		elseif not playingSound and g_soundManager:getIsSamplePlaying(waterTrailer.samples.refill) then
			if not Input.isKeyPressed(Input[aquaTraxxEffects.unloadKeys[1]]) then
				g_soundManager:stopSample(waterTrailer.samples.refill);
			end;
		end;
	end;

	if aquaTraxxEffects.keyDown then
		if not Input.isKeyPressed(Input[aquaTraxxEffects.unloadKeys[1]]) then
			if not Input.isKeyPressed(Input[aquaTraxxEffects.toggleCapKeys[1]]) then
				aquaTraxxEffects.keyDown = false;
			end;
		end;
	end;

	local settingsMenu = false;
	if g_gui:getIsGuiVisible() then
		if string.upper(tostring(FocusManager.currentGui)) == "SETTINGSCONTROLS" then
			settingsMenu = true;
		end;
	end;	
	if settingsMenu then
		if not g_gui:getIsGuiVisible() then
			aquaTraxxEffects.toggleCapKeys = getInputKeys:getMultipleKeys({"TOGGLE_COVER"});
			aquaTraxxEffects.toggleCapKeys = getInputKeys:splitKeysFromTable(aquaTraxxEffects.toggleCapKeys[1]);
			if dirtToMudConverter ~= nil then aquaTraxxEffects.unloadKeys = dirtToMudConverter.unloadKeys;
			else print("Error 'aquaTraxxEffects' cannot locate 'dirtToMudConverter'"); end;
		end;
	end;

end;

--source(aquaTraxxEffects.dir.."getInputKeys.lua");
aquaTraxxEffects.toggleCapKeys = getInputKeys:getMultipleKeys({"TOGGLE_COVER"});
aquaTraxxEffects.toggleCapKeys = getInputKeys:splitKeysFromTable(aquaTraxxEffects.toggleCapKeys[1]);

addModEventListener(aquaTraxxEffects);