﻿----------------------------------------------------------------------------
----Author: ViperGTS96------------------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design." --------------
----------------------------------------------------------------------------

dirtFill = {}
dirtFill.dir = g_currentModDirectory;
--source(dirtFill.dir.."dirtToMud.lua");
local modDescFile = loadXMLFile("modDesc", dirtFill.dir .. "modDesc.xml");
dirtFill.title = getXMLString(modDescFile, "modDesc.title.en");
dirtFill.author = getXMLString(modDescFile, "modDesc.author");
dirtFill.version = getXMLString(modDescFile, "modDesc.version");
delete(modDescFile);

function dirtFill:loadMap(savegame)

	if FillType.DIRT == nil then
		----------------------------------------Create FillType------------------------------------------------------------
		local key = dirtFill.dir.."images/";
		local baseDir = "";
		local fillPlaneColors = {0.05,0.05,0.05,0.9};
		local massforType = 0.001;--0.0005
		local showOnPriceTable = true;
		local pricePerLitre = 0.15;
		local maxSurfaceAngle = math.rad(50);
		local refFrame = g_currentMission.worldYReferenceFrame;

		local dirtDesc = g_fillTypeManager:addFillType("dirt", g_i18n:getText("fillType_dirt"), showOnPriceTable, pricePerLitre, massforType, maxSurfaceAngle, key.."hud_dirt.dds", key.."hud_dirt_sml.dds", baseDir, refFrame, fillPlaneColors, "$data/objects/pallets/fillablePallet/fillablePallet.xml");

		g_fillTypeManager:addFillTypeToCategory(dirtDesc.index, g_fillTypeManager.nameToCategoryIndex["BULK"]);

		showOnPriceTable = false;
		massforType = 0.002;
		maxSurfaceAngle = math.rad(10);
		local mudDesc = g_fillTypeManager:addFillType("mud", g_i18n:getText("fillType_mud"), showOnPriceTable, pricePerLitre, massforType, maxSurfaceAngle, key.."hud_mud.dds", key.."hud_mud_sml.dds", baseDir, refFrame, fillPlaneColors, "$data/objects/pallets/fillablePallet/fillablePallet.xml");
		
		g_fillTypeManager:addFillTypeToCategory(mudDesc.index, g_fillTypeManager.nameToCategoryIndex["BULK"]);
		--------------------------------------Create DenistyMap------------------------------------------------------------
		maxSurfaceAngle = math.rad(42);
		key = dirtFill.dir.."textures/";
		local allowsSmoothing = true; --Can be flattened like chaff
		local fillToGroundScale = 3.0;
		local collisionScale = 1.0;
		local collisionBaseOffset = 0.05;
		local minCollisionOffset = 0.0;
		local maxCollisionOffset = 0.05;
		local dirtDensityMap = g_densityMapHeightManager:addDensityMapHeightType("dirt", maxSurfaceAngle, collisionScale, collisionBaseOffset, minCollisionOffset, maxCollisionOffset, fillToGroundScale, allowsSmoothing, key.."dirt_diffuse.dds", key.."dirt_normal.dds", key.."dirt_diffuse_far.dds");
		maxSurfaceAngle = math.rad(10);
		allowsSmoothing = false;
		local mudDensityMap = g_densityMapHeightManager:addDensityMapHeightType("mud", maxSurfaceAngle, collisionScale, collisionBaseOffset, minCollisionOffset, maxCollisionOffset, fillToGroundScale, allowsSmoothing, key.."mud_diffuse.dds", key.."mud_normal.dds", key.."dirt_diffuse_far.dds");
		-----------------------------------Load Materials to new FillType----------------------------------------------------
		g_currentMission.dirtMaterialHolder = loadI3DFile(dirtFill.dir .. "materialHolders/dirt_materialHolder.i3d");
		g_currentMission.mudMaterialHolder = loadI3DFile(dirtFill.dir .. "materialHolders/mud_materialHolder.i3d");
		---------------------------------------------------------------------------------------------------------------------
		
		print("Register "..dirtFill.title.." : Load complete. Dirt: "..dirtDesc.name..":"..FillType.DIRT.."("..dirtDesc.index..")");	
		print("Register "..mudDesc.title.." : Load complete. Mud: "..mudDesc.name..":"..FillType.MUD.."("..mudDesc.index..")");
	end;
	
	g_currentMission.hud.fillLevelsDisplay:refreshFillTypes(g_fillTypeManager);
	
    addConsoleCommand("removeAllDirt", g_i18n:getText("clearAllDirtCC"), "clearAllDirt", self);
	addConsoleCommand("removeAllMud", g_i18n:getText("clearAllMudCC"), "clearAllMud", self);
end;

function dirtFill:delete()
    removeConsoleCommand("removeAllDirt");
    removeConsoleCommand("removeAllMud");
end;

function dirtFill:clearAllDirt()
	local size = getTerrainSize(g_currentMission.terrainRootNode);		
	DensityMapHeightUtil.removeFromGroundByArea(-size,-size,size,-size,-size,size, FillType.DIRT);
end;

function dirtFill:clearAllMud()
	local size = getTerrainSize(g_currentMission.terrainRootNode);		
	DensityMapHeightUtil.removeFromGroundByArea(-size,-size,size,-size,-size,size, FillType.MUD);
end;

addModEventListener(dirtFill);