----------------------------------------------------------------------------
-- @Author: ViperGTS96------------------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design." --------------
----------------------------------------------------------------------------
----------------------------------------------------------------------------

dirtToMud = {}
dirtToMud.textA = "Dirt Detected: Hold";
dirtToMud.textB = "to Unload";
addModEventListener(dirtToMud);
dirtToMudConverter = {}
dirtToMudConverter.unloadKeys = {};
dirtToMudConverter.renderInput = 0;
dirtToMudConverter.debugLines = true;
dirtToMudConverter.printRegistration = true;

function dirtToMud:loadMap()
	WaterTrailer.onLoad = Utils.appendedFunction(WaterTrailer.onLoad, dirtToMudConverter.onLoad);
	WaterTrailer.onUpdateTick = Utils.appendedFunction(WaterTrailer.onUpdateTick, dirtToMudConverter.onUpdateTick);
	dirtToMud.textA = g_i18n:getText("realMud_DirtDetected_A");
	dirtToMud.textB = g_i18n:getText("realMud_DirtDetected_B");
	print("Load mod: WaterTrailer DirtToMud");
end;

function dirtToMud:draw()
	if dirtToMudConverter.renderInput > 0 then
		--renderText(0.1, 0.1, 0.012, "Dirt Detected");
		local keyString = string.upper(string.gsub(dirtToMudConverter.unloadKeys[1],"KEY_",""));
		--g_currentMission:addExtraPrintText("Dirt Detected: Hold '"..keyString.."' to Unload");		
		g_currentMission:addExtraPrintText(dirtToMud.textA.." '"..keyString.."' "..dirtToMud.textB);
	end;
end;

function dirtToMudConverter:onLoad()
	local waterTrailer = self.spec_waterTrailer;
	local wheels = self.spec_wheels;
	if waterTrailer ~= nil and wheels ~= nil and self.dirtLocatorNode == nil then
		if waterTrailer.waterFillNode == nil then return; end;
		local d1,d2,d3 = localToWorld(waterTrailer.rootNode,0,0,1);
		local d4,d5,d6 = localToWorld(waterTrailer.rootNode,0,1,0);
		local rearOffset = ((Utils.getNoNil(self.sizeLength, 9))/2)+1;
		self.dirtLocatorNode = createTransformGroup("DirtToMudNode");
		link(waterTrailer.rootNode, self.dirtLocatorNode);		
		setTranslation(self.dirtLocatorNode, 0,0,-rearOffset);
		setDirection(self.dirtLocatorNode,d1,d2,d3,d4,d5,d6);
		if dirtToMudConverter.printRegistration then print("Registered 'dirtToMudConverter' to 'WaterTrailer'"); end;
	end;
end;

function dirtToMudConverter:onUpdateTick(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected)

	if self.dirtLocatorNode ~= nil then
		local waterTrailer = self.spec_waterTrailer;
		local playingSound = false;
		if isActiveForInput then
			if self:getFillUnitFillLevel(waterTrailer.fillUnitIndex) > 0 then
				local function getCoords(node, x)
					local sx,sy,sz = localToWorld(node, -x,0,0);
					local ex,ey,ez = localToWorld(node, x,0,0);
					sy = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, sx,sy,sz);
					ey = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, ex,ey,ez);
					local length = sx-ex; if length<0 then length = length *-1; end;
					local lengthB = sy-ey; if lengthB<0 then lengthB = lengthB *-1; end;
					local lengthC = sz-ez; if lengthC<0 then lengthC = lengthC *-1; end; 
					length = length+lengthB+lengthC;
					local radius = length/2;
					local dropLength = length*1.6666667;
					return sx,sy,sz, ex,ey,ez,length,radius,dropLength;
				end;
				local sx,sy,sz,ex,ey,ez,length,radius,dropLength = getCoords(self.dirtLocatorNode, 1.25);
				local detectedFillType = DensityMapHeightUtil.getFillTypeAtLine(sx,sy,sz, ex,ey,ez, radius);
				if detectedFillType == FillType.MUD then -- check for small amounts of dirt surrounded by mud.
					sx,sy,sz,ex,ey,ez,length,radius,dropLength = getCoords(self.dirtLocatorNode, 0.25);
					detectedFillType = DensityMapHeightUtil.getFillTypeAtLine(sx,sy,sz, ex,ey,ez, radius);
				end;
				if dirtToMudConverter.debugLines then drawDebugLine(sx,sy,sz, 0,0,1, ex,ey,ez, 0,0,1); end;
				if detectedFillType == FillType.DIRT then
					if Input.isKeyPressed(Input[dirtToMudConverter.unloadKeys[1]]) then
						local transferRate = waterTrailer.fillLitersPerSecond/10;
						--local waterDrainSpeed = waterTrailer.fillLitersPerSecond*(dt*0.0001);
						local waterDrainSpeed = (waterTrailer.fillLitersPerSecond/1000); waterDrainSpeed=waterDrainSpeed*(waterDrainSpeed*dt);
						local pickedUp, lineOffset = DensityMapHeightUtil.tipToGroundAroundLine(self, -(transferRate/2), FillType.DIRT, sx,sy,sz, ex,ey,ez, length, nil, 0, true, nil, true);
						if pickedUp ~= 0 then
							local dx1,dy1,dz1,dx2,dy2,dz2;
							local bsx,bsy,bsz = localToWorld(self.dirtLocatorNode, -1.75,0,-1);--back
							local bex,bey,bez = localToWorld(self.dirtLocatorNode, 1.75,0,-1);
							bsy = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, bsx,bsy,bsz)+0.001;
							bey = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, bex,bey,bez)+0.001;
							if dirtToMudConverter.debugLines then dx1,dy1,dz1,dx2,dy2,dz2 = bsx,bsy,bsz,bex,bey,bez; end;
							local dropped, _ = DensityMapHeightUtil.tipToGroundAroundLine(self, transferRate*2, FillType.MUD, bsx,bsy,bsz, bex,bey,bez, dropLength, nil, -lineOffset, false, nil, false); --needs to be false
							if dropped < 1 then						
								local fsx,fsy,fsz = localToWorld(self.dirtLocatorNode, -1.75,0,1);--front
								local fex,fey,fez = localToWorld(self.dirtLocatorNode, 1.75,0,1);
								fsy = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, fsx,fsy,fsz)+0.001;
								fey = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, fex,fey,fez)+0.001;
								if dirtToMudConverter.debugLines then dx1,dy1,dz1,dx2,dy2,dz2 = fsx,fsy,fsz,fex,fey,fez; end;
								dropped, _ = DensityMapHeightUtil.tipToGroundAroundLine(self, transferRate*2, FillType.MUD, fsx,fsy,fsz, fex,fey,fez, dropLength, nil, -lineOffset, false, nil, false);
								if dropped < 1 then								
									local lsx,lsy,lsz = localToWorld(self.dirtLocatorNode, -1,0,-1.75);--left
									local lex,ley,lez = localToWorld(self.dirtLocatorNode, -1,0,1.75);
									lsy = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, lsx,lsy,lsz)+0.001;
									ley = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, lex,ley,lez)+0.001;
									if dirtToMudConverter.debugLines then dx1,dy1,dz1,dx2,dy2,dz2 = lsx,lsy,lsz,lex,ley,lez; end;
									dropped, _ = DensityMapHeightUtil.tipToGroundAroundLine(self, transferRate*2, FillType.MUD, lsx,lsy,lsz, lex,ley,lez, dropLength, nil, lineOffset, false, nil, false);
									if dropped < 1 then	
										local rsx,rsy,rsz = localToWorld(self.dirtLocatorNode, 1,0,-1.75);--right
										local rex,rey,rez = localToWorld(self.dirtLocatorNode, 1,0,1.75);
										rsy = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, rsx,rsy,rsz)+0.001;
										rey = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, rex,rey,rez)+0.001;
										if dirtToMudConverter.debugLines then dx1,dy1,dz1,dx2,dy2,dz2 = rsx,rsy,rsz,rex,rey,rez; end;
										DensityMapHeightUtil.tipToGroundAroundLine(self, transferRate*2, FillType.MUD, rsx,rsy,rsz, rex,rey,rez, dropLength, nil, lineOffset, false, nil, false);
									end;
								end;
							end;
							if dirtToMudConverter.debugLines then drawDebugLine(dx1,dy1+0.01,dz1, 1,0,1, dx2,dy2+0.01,dz2, 1,0,1); end;
							self:addFillUnitFillLevel(self:getOwnerFarmId(), waterTrailer.fillUnitIndex, -waterDrainSpeed, FillType.WATER, ToolType.UNDEFINED, nil); --'Covers' block most ToolTypes..
							playingSound = true;
						end;
					end;
					dirtToMudConverter.renderInput = 10;
				end;
			end;
		end;
		--if self.isClient then
			if playingSound and not g_soundManager:getIsSamplePlaying(waterTrailer.samples.refill) then
				g_soundManager:playSample(waterTrailer.samples.refill);
			elseif not playingSound and g_soundManager:getIsSamplePlaying(waterTrailer.samples.refill) then
				if waterTrailer.manuallyDraining == nil or not waterTrailer.manuallyDraining then
					g_soundManager:stopSample(waterTrailer.samples.refill);
				end;
			end;
		--end;
	end;

	local settingsMenu = false;
	if g_gui:getIsGuiVisible() then
		if string.upper(tostring(FocusManager.currentGui)) == "SETTINGSCONTROLS" then
			settingsMenu = true;
		end;
	else		
		if dirtToMudConverter.renderInput > 0 then
			dirtToMudConverter.renderInput = dirtToMudConverter.renderInput-1;
		end;
	end;	
	if settingsMenu then
		if not g_gui:getIsGuiVisible() then
			dirtToMudConverter.unloadKeys = getInputKeys:getMultipleKeys({"TOGGLE_TIPSTATE","TOGGLE_TIPSTATE_GROUND","UNLOAD"});
			dirtToMudConverter.unloadKeys = getInputKeys:removeDuplicatesFromEnd(dirtToMudConverter.unloadKeys);
			dirtToMudConverter.unloadKeys = getInputKeys:splitKeysFromTable(dirtToMudConverter.unloadKeys[1]);
		end;
	end;
end;

--source(dirtToMudConverter.dir.."trailer/aquatraxx_ManualUnload.lua");
--source(g_currentModDirectory.."getInputKeys.lua");
--getInputKeys:printKeys(true);
dirtToMudConverter.unloadKeys = getInputKeys:getMultipleKeys({"TOGGLE_TIPSTATE","TOGGLE_TIPSTATE_GROUND","UNLOAD"});
dirtToMudConverter.unloadKeys = getInputKeys:removeDuplicatesFromEnd(dirtToMudConverter.unloadKeys);
dirtToMudConverter.unloadKeys = getInputKeys:splitKeysFromTable(dirtToMudConverter.unloadKeys[1]);

--[[for _, key in pairs(dirtToMudConverter.unloadKeys) do
	local stringToPrint = "";
	for _, keyPart in pairs(key) do
		stringToPrint = stringToPrint..keyPart.." ";
	end;
	print("key : "..stringToPrint);
end;]]