---------------------------------------------------------------------------
-- @Author: ViperGTS96-----------------------------------------------------
---------------------------------------------------------------------------
--------------------"The simplest design is the best design." -------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

getInputKeys = {};
getInputKeys.printKeys = false;
getInputKeys.xml = getUserProfileAppPath().."inputBinding.xml";

function getInputKeys:printKeys(toggledValue)
	getInputKeys.printKeys = toggledValue;
end;

function getInputKeys:getSingleKey(keyToFind)
	local keysFound = getInputKeys:getMultipleKeys({keyToFind});
	return keysFound;
end;

function getInputKeys:getMultipleKeys(keysToFind)

	local xmlFile = loadXMLFile("inputBinding", getInputKeys.xml)
	
	local i = 0;
	local keys = {};
	local keysLocated = 0;
	local numberOfkeysToFind = #keysToFind;

	while true do
		local objKey = string.format("inputBinding.actionBinding(%d)", i);
		local inputKey = getXMLString(xmlFile, objKey.."#action")
		if inputKey == nil or keysLocated >= numberOfkeysToFind then break; end;
		for _, keyToFind in pairs(keysToFind) do
			if inputKey == keyToFind then
				local keyString = getXMLString(xmlFile, objKey..".binding#input"); keyString = string.upper(keyString);
				local keyString2 = "";
				local keyString3 = "";
				local doubleKey, _ = string.find(keyString,"%sk");
				if doubleKey ~= nil and doubleKey > 0 then				
					keyString = string.sub(keyString, 5, doubleKey);
					keyString2 = string.sub(keyString, doubleKey);
					----					
					local tripleKey, _  = string.find(keyString2,"%sk");
					if tripleKey ~= nil and tripleKey > 0 then				
						keyString2 = string.sub(keyString, 5, tripleKey);
						keyString3 = string.sub(keyString, tripleKey);
					end;
				end;
				
				local keyStringKEY = string.sub(keyString, 5);
				keyStringKEY = string.lower(keyStringKEY);
				keyString = string.sub(keyString,1,4)..keyStringKEY;

				if keyString2 ~= "" then
					keyStringKEY = string.sub(keyString2, 5);
					keyStringKEY = string.lower(keyStringKEY);
					keyString2 = string.sub(keyString2,1,4)..keyStringKEY;
					if keyString3 ~= "" then
						keyStringKEY = string.sub(keyString3, 5);
						keyStringKEY = string.lower(keyStringKEY);
						keyString3 = string.sub(keyString3,1,4)..keyStringKEY;
					end;
				end;

				if keyString3 ~= "" then
					local refinedStringA = string.gsub(keyString,"key","KEY");
					local refinedStringB = string.gsub(keyString2,"key","KEY");
					local refinedStringC = string.gsub(keyString3,"key","KEY");
					keyString = {refinedStringA,refinedStringB,refinedStringC};
				elseif keyString2 ~= "" then
					local refinedStringA = string.gsub(keyString,"key","KEY");
					local refinedStringB = string.gsub(keyString2,"key","KEY");
					keyString = {refinedStringA,refinedStringB};
				else
					local refinedString = string.gsub(keyString,"key","KEY");
					keyString = {refinedString};
				end;
				table.insert(keys, keyString);

				keysLocated = keysLocated + 1;
			end;
		end;
        i = i + 1;
    end;

	delete(xmlFile);

	if getInputKeys.printKeys == true then
		for i, key in pairs(keys) do
			local stringToPrint = "";
			for _, keyPart in pairs(key) do
				stringToPrint = stringToPrint..keyPart.." ";
			end;
			print("getInputKeys located key : "..keysToFind[i].." = "..stringToPrint);
		end;
	end;

	return keys;

end;

function getInputKeys:removeDuplicatesFromEnd(keysTable)
	for i, key in pairs(keysTable) do --Remove dupliactes from end
		for _, keyPart in pairs(key) do
			for ii, dupeKey in pairs(keysTable) do
				for _, dupeKeyPart in pairs(dupeKey) do
					if dupeKeyPart == keyPart and ii ~= i then
						if dupeKey[ii+1] ~= nil then
							if dupeKey[ii+1] == key[i+1] then						
								if dupeKey[ii+2] ~= nil then
									if dupeKey[ii+2] == key[i+2] then							
										table.remove(keysTable,ii);
									end;
								else						
									table.remove(keysTable,ii);
								end;
							end;
						else
							table.remove(keysTable,ii);
						end;
					end;
				end;
			end;
		end;
	end;
	return keysTable;
end;

function getInputKeys:removeDuplicatesFromStart(keysTable)
	for i, key in pairs(keysTable) do --Remove dupliactes from beginning
		for _, keyPart in pairs(key) do
			for ii, dupeKey in pairs(keysTable) do
				for _, dupeKeyPart in pairs(dupeKey) do
					if keyPart == dupeKeyPart and i ~= ii then
						if key[i+1] ~= nil then
							if key[i+1] == dupeKey[ii+1] then						
								if key[i+2] ~= nil then
									if key[i+2] == dupeKey[ii+2] then							
										table.remove(keysTable,i);
									end;
								else						
									table.remove(keysTable,i);
								end;
							end;
						else
							table.remove(keysTable,i);
						end;
					end;
				end;
			end;
		end;
	end;
	return keysTable;
end;

function getInputKeys:splitKeysFromTable(keyTable)
	local key1,key2,key3 = unpack(keyTable);
	if key3 ~= nil then
		keyTable = {key3,key2,key1};
	elseif key3 ~= nil then
		keyTable = {key2,key1};
	else
		keyTable = {key1};
	end;
	return keyTable;
end;

--[[

-------
--Use--
-------

source(myMod.basedir.."getInputKeys.lua"); -- to load script.
getInputKeys:printKeys(true); -- if you'd like them printed to the logFile
local keysToFind = {"TOGGLE_TIPSTATE","TOGGLE_TIPSTATE_GROUND","UNLOAD"}; --Desired keys to search for.
local newTable = getInputKeys:getMultipleKeys(keysToFind); --Get keys from inputs..
newTable = getInputKeys:removeDuplicatesFromEnd(newTable); -- Remove duplicates..

for _, key in pairs(newTable) do  -- Re-confirm list of returned keys if desired..
	local stringToPrint = "";
	for _, keyPart in pairs(key) do
		stringToPrint = stringToPrint..keyPart.." ";
	end;
	print("key : "..stringToPrint);
end;

]]