----------------------------------------------------------------------------
-- @Author: ViperGTS96------------------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design." --------------
----------------------------------------------------------------------------
----------------------------------------------------------------------------

rainNow = {}
rainNow.dir = "";
rainNow.file = "particleSystems/rain.i3d";
rainNow.sndFile = "particleSystems/rain.ogg";
rainNow.rainSnd = createSample("rainSound");
rainNow.sndVolumeIn = 0.15;
rainNow.sndVolumeOut = 0.5;
rainNow.sndVolume = rainNow.sndVolumeOut;
rainNow.btnDown = false;
rainNow.rainIsActive = false;
rainNow.overrideRain = mudFX.overrideRainModel;
rainNow.weatherState = 0;
rainNow.nextWeatherState = 0;
rainNow.dirtColor = {};
addModEventListener(rainNow);

function rainNow:loadRain(self, playSound)	
	if g_currentMission.mudFX_Rain == nil then
		rainNow.rainIsActive = true;
		Wipers.forcedState = 1;
		--WeatherType.SUN = false;
		--[[if realDirtColor ~= nil then
			rainNow.dirtColor = realDirtColor.colors.dryDirt;
			realDirtColor.colors.dryDirt = realDirtColor.colors.mud;
		end;]]
		g_currentMission.mudFX_Rain = {};
		g_currentMission.mudFX_Rain.rainIsActive = rainNow.rainIsActive;
		g_currentMission.mudFX_Rain.node = loadI3DFile(rainNow.dir..rainNow.file, false, false, false);
		g_currentMission.mudFX_Rain.node = getChildAt(g_currentMission.mudFX_Rain.node,0);
		link(getRootNode(),g_currentMission.mudFX_Rain.node);
		mudFX.overrideRain = rainNow.rainIsActive;
		if not self.isServer and playSound then
			playSample(rainNow.rainSnd,0,rainNow.sndVolume,0,0,0);
		end;
	end;
	
	--[[g_currentMission.environment.weather.windUpdater.targetCirrusSpeedFactor = 25;
	for windUpdater,windUpdateInfo in pairs(g_currentMission.environment.weather.windUpdater) do	
		print(tostring(windUpdater).." : "..windUpdateInfo);--:getCurrentValues()
		windUpdateInfo = 0;
	end;]]
end;

function rainNow:loadMission()
	--[[for _,weatherObject in pairs(g_currentMission.environment.weather.weatherObjects) do			
		if weatherObject.filename == "$data/sky/rain.i3d" then
			weatherObject.filename = mudFX.dir..rainNow.file;
			print(weatherObject.filename);
		end;
	end;]]
	i = 1;
	while true do
		local child = getChildAt(getRootNode(),i);
		if child == nil then break; end;
		nodeName = getName(child);
		if nodeName == "rain" then
			rainNow.rainRootNode = child;
			print("Override : rain replaced");
			break;
		end;
		i=i+1;
	end;
end;

if rainNow.overrideRain then
	Mission00.load = Utils.appendedFunction(Mission00.load, rainNow.loadMission);
end;

function rainNow:deleteRain(self)
	if g_currentMission.mudFX_Rain ~= nil then
		rainNow.rainIsActive = false;
		g_currentMission.mudFX_Rain.rainIsActive = rainNow.rainIsActive;
		Wipers.forcedState = 0;
		--[[if realDirtColor ~= nil then
			realDirtColor.colors.dryDirt = rainNow.dirtColor;
		end;]]
		if g_currentMission.mudFX_Rain.node ~= nil then
			delete(g_currentMission.mudFX_Rain.node);
		end;
		g_currentMission.mudFX_Rain = nil;	
		mudFX.overrideRain = rainNow.rainIsActive;
		--if not self.isServer then
			if isSamplePlaying(rainNow.rainSnd) then
				stopSample(rainNow.rainSnd, 0, 0);
			end;
		--end;
	end;
end;

function rainNow:toggleRainWeather(dt)	
	if rainNow.rainIsActive then				
		rainNow:deleteRain(self);
	else
		rainNow:loadRain(self, true);
	end;
end;

function rainNow:delete(dt)
	removeConsoleCommand("toggleRainWeather");
end;

function rainNow:loadMap(savegame)
	Enterable.onPostUpdate = Utils.appendedFunction(Enterable.onPostUpdate, rainNow.updateEntered);
	if mudFX.dir ~= "" then
		rainNow.dir = mudFX.dir;
		loadSample(rainNow.rainSnd, rainNow.dir..rainNow.sndFile, false);
		setSamplePitch(rainNow.rainSnd, 1.0);
	end;
	addConsoleCommand("toggleRainWeather", g_i18n:getText("realMud_toggleRainCC"), "toggleRainWeather", self);
end;

function rainNow:update(dt)
	if rainNow.overrideRain then
		if getVisibility(rainNow.rainRootNode) then
			setVisibility(rainNow.rainRootNode, false);
			if not rainNow.rainIsActive then
				rainNow:loadRain(self, false);
			end;
		end;
	else
		if rainNow.rainIsActive then
			g_currentMission.environment.groundWetness = 1.0;
			local rainScale = g_currentMission.environment.weather:getRainFallScale()
			local timeSinceLastRain = g_currentMission.environment.weather:getTimeSinceLastRain()
			if not (rainScale <= 0.1 and timeSinceLastRain > 20) then			
				rainNow:deleteRain(self);
			end;
		end;
	end;
end;

function rainNow:updateEntered()	
	local spec = self.spec_enterable
    if spec.isEntered then
		if spec.activeCamera ~= nil then
			local camera = spec.activeCamera;
			if camera.isInside ~= nil and camera.isInside then
				if rainNow.sndVolume ~= rainNow.sndVolumeIn then	
					rainNow.sndVolume = rainNow.sndVolumeIn;
					if isSamplePlaying(rainNow.rainSnd) then
						setSampleVolume(rainNow.rainSnd, rainNow.sndVolume);
					end;
				end;
			elseif rainNow.sndVolume ~= rainNow.sndVolumeOut then
				rainNow.sndVolume = rainNow.sndVolumeOut;
				if isSamplePlaying(rainNow.rainSnd) then
					setSampleVolume(rainNow.rainSnd, rainNow.sndVolume);
				end;
			end;
		end;
	elseif rainNow.sndVolume ~= rainNow.sndVolumeOut then
		rainNow.sndVolume = rainNow.sndVolumeOut;
		if isSamplePlaying(rainNow.rainSnd) then
			setSampleVolume(rainNow.rainSnd, rainNow.sndVolume);
		end;
	end;
end;

function GameInfoDisplay:getWeatherStates()
    local sixHours = 6 * 60 * 60 * 1000;
    local env = self.environment;
    local dayPlus6h, timePlus6h = env:getDayAndDayTime(env.dayTime + sixHours, env.currentDay);
    local weatherState = env.weather:getWeatherTypeAtTime(env.currentDay, env.dayTime);
    local nextWeatherState = env.weather:getWeatherTypeAtTime(dayPlus6h, timePlus6h);
	if rainNow.rainIsActive then		
		rainNow.weatherState = weatherState;
		rainNow.nextWeatherState = nextWeatherState;
		weatherState = 3;
		nextWeatherState = weatherState;
	elseif rainNow.weatherState ~= 0 then		
		weatherState = rainNow.weatherState;
		nextWeatherState = rainNow.nextWeatherState;
		rainNow.weatherState = 0;
		rainNow.nextWeatherState = 0;
	end;
    return weatherState, nextWeatherState;
end;