----------------------------------------------------------------------------
--------------------"The simplest design is the best design." --------------
----------------------------------------------------------------------------
----------------------------------------------------------------------------
-- Copyright (C)ViperGTS96, Confidential, All Rights Reserved.--------------
----------------------------------------------------------------------------

source(Utils.getFilename("mudFX.lua", g_currentModDirectory));

mudFXRegister = {};
mudFXRegister.modDirectory = g_currentModDirectory;
local modDesc = loadXMLFile("modDesc", g_currentModDirectory .. "modDesc.xml");
mudFXRegister.version = getXMLString(modDesc, "modDesc.version");

function installSpec()
	if g_specializationManager:getSpecializationByName("mudFX") == nil then
		if mudFX == nil then 
			print("ERROR: unable to find source file 'mudFX'");
		else 
			for typeName, typeDef in pairs(g_vehicleTypeManager.vehicleTypes) do
				if typeDef ~= nil and (typeName ~= "locomotive") then 
					local isWashable = false;
					local isAnimated = false;
					for name, spec in pairs(typeDef.specializationsByName) do
						if name == "washable" then 
							isWashable = true;
						elseif name == "animatedVehicle" then 
							isAnimated = true;
						end;
					end;
					if isWashable and isAnimated then
						typeDef.specializationsByName["mudFX"] = mudFX;
						table.insert(typeDef.specializationNames, "mudFX");
						table.insert(typeDef.specializations, mudFX);
					end;
				end;
			end;
		end;	
	end;
end;

function incompatibleWetness()
	if g_modIsLoaded["FS19_RM_Seasons"] then
		mudFX:disableWetnessCheck(true);
		print("Real Mud detected 'Seasons Mod': Wetness check Disabled");
	else
		mudFX:disableWetnessCheck(false);
	end;
end;

FSBaseMission.loadMapFinished = Utils.prependedFunction(FSBaseMission.loadMapFinished, incompatibleWetness);
VehicleTypeManager.validateVehicleTypes = Utils.prependedFunction(VehicleTypeManager.validateVehicleTypes, installSpec);

mudFX:setDir(mudFXRegister.modDirectory);